# CVS $Id: acc.tcl,v 1.1 1995/02/03 17:14:56 zibi Exp $
#
# a minimal test of the menubar and pulldown widgets
#
# use the object option allowDuplicateName to make separator with
# identical names.
#
source "tools.tcl"

set menuList1 {
    {pd File F}
        {bt "New..." N "Ctrl<Key>N" "Ctrl+N" }
        {bt  Exit    E "<Key>Escape" "Escape" QuitCB}
    {pd Edit E}
        {bt Cut   C "Ctrl<Key>X" "Ctrl+X" }
        {bt Copy  o "Ctrl<Key>C" "Ctrl+C" }
        {bt Paste P "<Key>F4" "F4" }
    {sp}
    {bt Delete D "<Key>Delete" Delete }
    {pd View  V}
        {bt Some  S "Alt<Key>S" "Alt+S" }
        {bt Parts P "<Key>Prior" "Page Up"}
    {pd Printer  P}
        {bt "New Printer"  N "<Key>Next" "Page Down"}
        {sp}
        {tb "Good Printer" "" "" "" toggleChangedCB  0}
        {tb "Bad Printer"  "" "" "" toggleChangedCB  1}
        {tb "Ugly Printer" "" "" "" toggleChangedCB  0}
    {pd Test  T}
        {bt "Sensitive Target..." }
        {bt "Make UnSensitive" "" "" "" "setSenCB 0" }
        {bt "Make Sensitive"   "" "" "" "setSenCB 1" }
}


#------------------------------------------------------------

proc setSenCB {state cbs} {
    set dlog [keylget cbs dialog]

    set button [VxMenuGetButton $dlog "Sensitive Target..."]
    VtSetSensitive $button $state
}

proc toggleChangedCB {cbs} {
    set target [keylget cbs widget]
    set dlog [keylget cbs dialog]

    set name [VtGetValues $target -label]
    set tstate [VtGetValues $target -set]

    set label [VxGetVar $dlog label]

    VtSetValues $label -label "You toggled $name, it's set to <$tstate>"
}

#
# Set the label to the name of the menu item that 
# got activated
#
proc genericCB {cbs} {
    set target [keylget cbs widget]
    set dlog   [keylget cbs dialog]
    set label [VxGetVar $dlog label]

    set name [VtGetValues $target -label]

    VtSetValues $label -label "Menu Item Selected is : $name"
}
set fn [VtOpen testmenu]
set dlog [VtFormDialog $fn.form -title "Menu Test"]

# Create the menu bar
set menubar [VtMenuBar $dlog.mb -helpMenuItemList {ON_VERSION INDEX TUTORIAL} ]
VxMenu $dlog $menubar $menuList1 "genericCB"

set form [VtForm $dlog.form -leftSide FORM -below $menubar]

set topLabel [VtLabel $form.topLabel \
	      -label "This top menu is an example of using the default help" \
	      -font medPlainFont]

set label  [VtLabel $form.label -label "No Callback Yet" \
	    -MOTIF_topOffset 10 \
	    -labelLeft \
	    -font largeBoldFont]


VxSetVar $dlog label $label

set bottomLabel [VtLabel $form.bottomLabel \
		 -label "This doesn't do anything, test accelerators from here." \
		 -MOTIF_topOffset 30 \
		 -font medPlainFont]

set pb [VtText $dlog.pb]

VtShow $dlog
VtMainLoop


