# CVS $Id: combo2.tcl,v 1.2 1995/05/04 11:10:05 zibi Exp $

#
# a minimal test of the combobox widget
#

proc quitCB {cbs} {
    VtClose
}

proc comboChangedCB {cbs} {
	global label1
	global fn

	VtSetValues $label1 \
		-label "Changed: [keylget cbs value]"

}

proc comboActivateCB {cbs} {
	global label2

	VtSetValues $label2 \
		-label "Activate: [keylget cbs value]"

}

proc comboDroppedCB {cbs} {
	global label3

	VtSetValues $label3 \
		-label "Drop: [keylget cbs value]"
}

set app [VtOpen "testcombo"]

set fn [VtFormDialog $app.form -title "ComboBox Test"]

set label1 [VtLabel $fn.label1 -label "Changed: No Callback Yet" ]
set label2 [VtLabel $fn.label2 -label "Activate: No Callback Yet" ]
set label3 [VtLabel $fn.label3 -label "Drop: No Callback Yet" ]

set cb1 [VtComboBox $fn.combo1 \
	-dropListCallback comboDroppedCB\
	-valueChangedCallback comboChangedCB\
	-callback comboActivateCB \
	-itemList {one two three four five averylongiteminthelistjustforkicks seven last} \
	-value two \
	-rightSide FORM\
	-xmArgs "XmNbackground red"]

set cb2 [VtComboBox $fn.combo2 \
	     -dropListCallback comboDroppedCB\
	     -valueChangedCallback comboChangedCB \
	     -callback comboActivateCB \
	     -itemList {one two three four} \
	     -topSide $cb1]

set cb3 [VtComboBox $fn.combo3 \
	     -dropListCallback comboDroppedCB\
	     -valueChangedCallback comboChangedCB \
	     -callback comboActivateCB \
	     -itemList {one two three four} \
	     -columns 40 \
	     -topSide $cb2\
	     -xmArgs "XmNbackground red"]

VtPushButton $fn.quit -label Exit -callback quitCB \

VtShow $fn

VtMainLoop

