/* CVS $Id: vtcl.h,v 1.1 1995/02/03 16:11:06 zibi Exp $ */
/*-------------------------------------------------------------------------
  Copyright (c) 1994           		The Santa Cruz Operation, Inc.
  -------------------------------------------------------------------------
  All rights reserved.  No part of this  program or publication may be
  reproduced, transmitted, transcribed, stored  in a retrieval system,
  or translated into any language or computer language, in any form or
  by any  means,  electronic, mechanical, magnetic, optical, chemical,
  biological, or otherwise, without the  prior written  permission of:

           The Santa Cruz Operation, Inc.  (408) 425-7222
           400 Encinal St, Santa Cruz, CA  95060 USA
  -------------------------------------------------------------------------

  SCCS  : @(#) vtcl.h 11.2 95/01/31 
  Author: wing
  Date  : 11-Jan-94
  File  : vtcl.h was wstcl.h

  Description:
	header file for wstcl routines.  This is used by programs outside
	of wstcl.

  Modification History:
  M002,	09.21.94, hops
        This file renamed from wstcl.h
  M001,	13-Apr-94, shawnm
	include tcl.h for Tcl_Interp define
  M000,	11-Jan-94, wing
	created
  -----------------------------------------------------------------------*/

#ifndef VTCL_H

#define VTCL_H

#include <tcl.h>

/* Function prototype for function called in response to input or remove */
/* the function should return a Tcl status TCL_OK etc. */
typedef int (*INPUT_PROC)(Tcl_Interp *, int, caddr_t);

enum {	INPUT_SUCCESS = 0,	/* everything ok */
	INPUT_DUP,		/* duplicate file descrip */
	INPUT_NOT_FOUND,	/* couldn't find file descip in CRemoveInput */
	INPUT_MEM_ALLOC,	/* memory allocation error */
	INPUT_FAILURE		/* generic failure code */
};

#ifdef __cplusplus
extern "C" {
#endif 

extern int WsAddInput(FILE *, int, INPUT_PROC, INPUT_PROC, caddr_t);
extern int WsRemoveInput(int);

#ifdef __cplusplus
}
#endif 

#endif  /* VTCL_H */

